//================================================================================================
// $Id: cgselector.h 6308 2023-01-16 20:16:41Z aron $
//
// Project:
//		Welltype Compiler
// Contents:
//		AST node selector
// Authors:
//		Aron Barath, 2014-2023
//================================================================================================
// Copyright (c) Aron Barath
//================================================================================================

#ifndef WTC_CGSELECTOR_H
#define WTC_CGSELECTOR_H

#include <set>
#include <deque>
#include "wtparser/astvisitor.h"
#include "wtparser/astnode.h"

namespace wtc
{
namespace codegen
{

template<int N> struct dummy_type { };

template<typename B, bool dive,
	typename T1=B, typename T2=dummy_type<2>, typename T3=dummy_type<3>,
	typename T4=dummy_type<4>, typename T5=dummy_type<5>, typename T6=dummy_type<6>,
	typename T7=dummy_type<7>, typename T8=dummy_type<8> >
struct Selector : public wtast::AstVisitor
{
	typedef std::set<B*> set_t;
	typedef std::deque<B*> container_t;
	typedef typename container_t::iterator iterator;
	set_t set;
	container_t result;
	bool empty() const { return result.empty(); }
	std::size_t size() const { return result.size(); }
	iterator begin() { return result.begin(); }
	iterator end() { return result.end(); }

	Selector(wtast::AstNode* astnode) : wtast::AstVisitor() { astnode->Accept(this); }

	bool Visit(T1* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T2* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T3* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T4* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T5* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T6* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T7* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
	bool Visit(T8* elem) { if(set.insert(elem).second) { result.push_back(elem); } return dive; }
};

} // codegen
} // wtc

#endif // WTC_CGSELECTOR_H
