#ifndef WTRUNTIME_SYM_H
#define WTRUNTIME_SYM_H

#include "config.h"
#include "../welltype/sym.h"

/* allocates a symbol skeleton from the system memory with the specified */
/* size, and fills out the given fields -- it is the callers task to build */
/* the actual symbol data (note: symbol data must not allocate further */
/* memory!), except symbol name, which is filled ('namelen' must not */
/* include terminating zero (symbol name will be allocated after the */
/* specified symbol size) */
struct wtr_sym* wtr_sym_new(struct wtr_vm* const vm, enum wtr_symtype symtype,
	const enum wtr_symbind symbind, struct wtr_symtab* const symtab,
	size_t size, const char* name, size_t namelen);

/* bind symbol if needed */
wt_error wtr_sym_bind(struct wtr_vm* const vm, struct wtr_sym* const sym);

/* resolve symbol */
wt_error wtr_sym_resolve(struct wtr_vm* const vm, struct wtr_sym* const sym,
	struct wtr_symtab* const symtab,
	struct wtr_sym* (*get_usertype)(struct wtr_symtab* const symtab,
	wt_uint32_t usertype_id));

void wtr_sym_unreg_gid(struct wtr_vm* const vm, struct wtr_sym* const sym);
void wtr_sym_release(struct wtr_vm* const vm, struct wtr_sym* const sym);

int wtr_sym_cmp(struct wtr_vm* const vm, struct wtr_sym* const lhs,
	struct wtr_sym* const rhs);

#endif /* WTRUNTIME_SYM_H */
