#ifndef WTRUNTIME_SYMTAB_H
#define WTRUNTIME_SYMTAB_H

#include "config.h"
#include "wtruntime.h"
#include "types.h"

struct wtr_sym;
struct wtr_program;
struct wtr_vector;

struct wtr_symtab
{
	/* linking symtabs together */
	struct wtr_node link_symtabs;

	/* reference count is increased if a loaded program uses a symbol from */
	/* the symtab */
	size_t refcount;

	/* symtab might be associated to a program, but this will be NULL, if */
	/* symtab belongs to the VM */
	struct wtr_program* prog;

	/* symtab-implementation defined symbol lookup function */
	struct wtr_sym* (*lookup)(struct wtr_symtab* const symtab,
		struct wtr_vm* const vm, struct wtr_sym* const sym);

	/* destroy the symtab, including all allocated memory */
	void (*destroy)(struct wtr_symtab* const symtab, struct wtr_vm* const vm);
};

void wtr_symtab_symvec_destroy(struct wtr_vm* const vm,
	struct wtr_vector* const symvec);

#endif /* WTRUNTIME_SYMTAB_H */
